<?php
/*
 * addressbook.php -- Version 31-May-2006
 *
 * Copyright (c) 2003-2006 Jochen Kupperschmidt <webmaster@nwsnet.de>
 * Released under the terms of the GNU General Public License
 *   _                               _
 *  | |_ ___ _____ ___ _ _ _ ___ ___| |_
 *  |   | . |     | ._| | | | . |  _| . /
 *  |_|_|___|_|_|_|___|_____|___|_| |_|_\
 *    http://homework.nwsnet.de/
 */

# Setup database connection.
require_once('./lib/Database.class.php');
$db = new Database('yourHost', 'yourUser', 'yourPassword', 'yourDatabase');

# Setup template engine.
require_once('./lib/phemplate.class.php');
$tpl = new phemplate();
$tpl->set_file('page', 'addressbook.tpl');

# Assign form values
$tpl->set_var('SCRIPT_NAME', $_SERVER['SCRIPT_NAME']);

# Retrieve list of persons and pass it to the template.
$pattern = $_GET['pattern'] ? $_GET['pattern'] : '';
$persons = getPersons($pattern);
$tpl->set_var('pattern', $pattern);
$tpl->set_loop('person', $persons);
$tpl->set_var('person_count', count($persons));

# Output the full page.
echo $tpl->process('', 'page', TPL_LOOP | TPL_OPTIONAL);

# ---------------------------------------------------------------- #

function getPersons($pattern='')
{
    global $db;

    if ($pattern) {
        # Build WHERE clause if search pattern specified.
        $where = '
        WHERE (firstname LIKE ?)
           OR (lastname LIKE ?)
           OR (nickname LIKE ?)
           OR (street LIKE ?)
           OR (city LIKE ?)
           OR (email LIKE ?)
           OR (jabber LIKE ?)
        ';
        $params = array_fill(0, 7, '%' . $pattern . '%');
    } else {
        $where = '';
        $params = array();
    }

    # Execute database query and return the result.
    return $db->getRows('
        SELECT firstname, lastname, nickname, street, zipcode, city,
               telephone, cellphone, email, jabber, website, photo,
               DATE_FORMAT(birthday, \'%d-%b-%Y\') AS birthday
        FROM `addressbook`
        ' . $where . '
        ORDER BY nickname;
        ', $params);
}
?>